<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070629;14310400">
	<META NAME="CHANGED" CONTENT="20070710;13054000">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Convert CFG to PDA (LR)
</B></FONT>
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A><U><BR></U><A HREF="#how to"><U>How
to Convert CFG to PDA (LR)</U></A></P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">We will convert a context free grammar
into a pushdown automaton using the SLR(1) parsing method.</P>
<P STYLE="margin-bottom: 0in">The idea behind the conversion from a
CFG to an NPDA using the SLR(1) parsing method, is to push terminals
from the strings on the stack, pop right-hand sides of productions
off the stack, and push their left-hand sides on the stack, until the
start variable is on the stack.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A>How
to Convert CFG to PDA (LR)</H2>
<P><A NAME="language1"></A>We will begin by loading the same grammar
that we used for building the LL(1) parse table. You can view that
grammar rule in our <B>Build LL(1) Parse Table </B>tutorial. (or you
can download the file, <A HREF="grammarToLL.jff">grammarToLL.jff</A>).
After loading the grammar, click on <B>Convert </B>and click <B>Convert
CFG to PDA (LR)</B>. Now, your JFLAP window should look like this : 
</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/example1_1.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=643 HEIGHT=503 BORDER=0></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P STYLE="margin-bottom: 0in">Just like the conversion to PDA using
LL parsing, we need to add transitions between the states. However
this time transitions are going to be quite different, because we are
using a different parsing method. Still, our goal is to reach state
q2. For each terminal, add a loop transition on state q0 that reads
the terminal in the input and pushes it on the stack. For each
production, add a loop transition on state qo that pops the right
side of the production and pushes on the left side of the production
from the stack. Therefore, for production “S-&gt;aABb”, we would
put transition “lambda, bBAa ; S” on state q0. We can convert all
the other productions into transitions. After we have successfully
completed them, the window will look like : 
</P>
<P STYLE="margin-bottom: 0in"><B>*NOTE </B>: You can click the
production on the left side and click on <B>Create Selected</B> to
add the corresponding transition in the PDA.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic2" ALIGN=BOTTOM WIDTH=643 HEIGHT=503 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">Now, we
have successfully transformed the context-free grammar to a pushdown
automaton. We can export this PDA and test it on some inputs and
compare it to the original CFG. After exporting the PDA, your new
JFLAP window should look like :</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=685 HEIGHT=546 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now let's test many strings.
Click on <B>Input, </B>then click on <B>Multiple Run</B>. In the
<B>Multiple Run </B>window, type input “acb”, “aaaccbcb”,
“aa”, “abbbba”, “accb”, “aaccb”, “bcb”. When you
click <B>Run Inputs</B>, you might receive a message like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=685 HEIGHT=546 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Notice that string “acb”
is already accepted by PDA. However, when PDA is parsing the string
“aaaccbcb”, it generated 674 configurations and still did not
achieve the string yet. This does not necessarily mean that the
string is impossible to derive. But, it also implies that it could be
the case that the string is impossible to derive. So let's press <B>Yes</B>
button and see what happens. After clicking <B>Yes </B>to couple of
times, you will notice that the string “aaaccbcb” is accepted
eventually.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">However,
this is not always the case. Notice when you reach string “aa”,
if you keep clicking on the <B>Yes</B> button, your configurations
will get bigger and you will still not achieve the string. In this
case, it would be wise not to continue. Select <B>No</B> for this
string. After finishing the parsing, your window should look like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=685 HEIGHT=546 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">If you run these same inputs
on the grammar window using <B>Multiple Run</B>, you will get the
same result. Your <B>Multiple</B> <B>Run </B>window should look like
this after running : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_6.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=623 HEIGHT=512 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Converting CFG to PDA (LR). Thanks for reading!</B></P>
</BODY>
</HTML>